module caffeinebeverage;

import std.stdio : writeln;

abstract class CaffeineBeverage
{
    final void prepareRecipe()
    {
        boilWater();
        brew();
        pourInCup();
        addCondiments();
    }

    void brew();

    void addCondiments();

    void boilWater()
    {
        writeln("Boiling water");
    }

    void pourInCup()
    {
        writeln("Pouring into cup");
    }
}
